; logical operations: shift right (4-bit). Shift bits one position to the right, discarding excess LSB bit. MSB filler bit is 0.
; input on paper:
;  0: input nibble
; output on paper:
;  1: output nibble
;
;
; SRA (shift right A)
;

@start:
	BTC STATUS, 2
	BTS STATUS, 3
	LDA 0
	MOVE DI, A
	MOVE SI, A
	LDAS
	CALL SRA
	BTS STATUS, 2
	STAD
	FIN


@SRA:
	STAD
	ADDAA
	STAD
	SKC
	JMP NO_C1
	BTS SI, 2
@NO_C1:
	ADDAA
	STAD
	SKC
	JMP NO_C2
	BTS SI, 1
@NO_C2:
	ADDAA
	STAD
	SKC
	JMP NO_C3
	BTS SI, 0
@NO_C3:
	LDA 1
	MOVE DI, A
	MOVE A, SI
	RET
